{$A+} {Word allign}
{$F-} {Use NEAR calls}
{$G-} {8086 instructions}
{$D-} {Strip debug information}
{$B-} {Short boolean evaluation}
{$L-} {Do not generate local symbols information}
{$M, 1024,0,0}
TYPE
  ColorNames = (Red, Green, Blue);
  TPalColor  = ARRAY[ColorNames] OF Byte;
  TPal       = ARRAY[0..255] OF TPalColor;

VAR
  Pal     : TPal;
  Screen  : ARRAY[1..400] OF TPalColor;
  Clear   : ARRAY[1..160] OF Char;
  Index   : Integer;


 PROCEDURE Friday13_LOGO; EXTERNAL; {$L FRI13BBS.OBJ}


 PROCEDURE VRetrace; ASSEMBLER;
 ASM
   MOV DX, 03DAh
   @1: IN AL, DX; TEST AL,08h;  JZ @1;
   @2: IN AL, DX; TEST AL,08h; JNZ @2;
 END;

 PROCEDURE SetBorderColor(Color:Byte); ASSEMBLER;
 ASM
	MOV	AH, $0B
	MOV	BH, 0
	MOV	BL, Color
	INT	10h
 END;

 PROCEDURE ShowLOGO; ASSEMBLER;
 ASM
    PUSH DS
    MOV AX, CS
    MOV DS, AX
    MOV AX, 0B800h
    MOV ES, AX
    XOR DI, DI
    MOV SI, OFFSET Friday13_LOGO
    MOV CX, 4000 / 2
    REP MOVSW
    MOV AX, 040h
    MOV ES, AX
    MOV AL, 1
    MOV ES:[$50], AL  { Cursor X }
    MOV AL, 23
    MOV ES:[$51], AL  { Cursor Y }
    POP DS
 END;


{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}
PROCEDURE GetVGAPal(VAR APal:TPal); ASSEMBLER;
CONST PalRead=$3C7; PalData=$3C9;
ASM
     LES  DI, APal
     MOV  CX, 256 * 3
     MOV  DX, PalRead  {Write}
     MOV  AL, 0
     OUT  DX, AL       {Set first color}
     MOV  DX, PalData  {Data}
  @Get:
     IN   AL, DX
     STOSB
     LOOP @Get
END;

PROCEDURE SetVGAPal(VAR APal:TPal); ASSEMBLER;
CONST CrtcPort=$3DA; PalWrite=$3C8; PalData=$3C9;
ASM
     PUSH DS
     LDS  SI, APal
     MOV  CX, 256 * 3

     MOV  DX, PalWrite {Write}
     MOV  AL, 0
     OUT  DX, AL       {Set first color}
     MOV  DX, PalData  {Data}

  @Get:
     LODSB
     OUT DX, AL
     LOOP @Get

     POP  DS
END;

PROCEDURE SetIntensity(a1,a2,a3:Byte);
VAR I:Byte;
BEGIN
  Port[$3C8] := $00;
  VRetrace;
  FOR I := 0 TO 255 DO
  BEGIN
    Port[$3C9] := Pal[I,Red]   * a1 DIV 63;
    Port[$3C9] := Pal[I,Green] * a2 DIV 63;
    Port[$3C9] := Pal[I,Blue]  * a3 DIV 63;
  END;
END;

PROCEDURE FadeDownMax;
VAR I:Byte;
BEGIN
  FOR I := 63 DOWNTO 0 DO SetIntensity(I,I,I);
END;

PROCEDURE FadeUpMax;
VAR I:Byte;
BEGIN
  FOR I := 0 TO 63 DO SetIntensity(I,I,I);
END;
{+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++}


PROCEDURE SetBGGlag;
VAR Index:Integer;
BEGIN
  FOR Index := 1 TO 63 DO
  BEGIN
    Screen[Index,Red]   := Index;
    Screen[Index,Green] := Index;
    Screen[Index,Blue]  := Index;
  END;
  FOR Index := 64 TO 127 DO
  BEGIN
    Screen[Index,Red]   := 127-Index;
    Screen[Index,Green] := 127-Index;
    Screen[Index,Blue]  := 127-Index;
  END;

  FOR Index := 128 TO 191 DO
  BEGIN
    Screen[Index,Red]   := 0;
    Screen[Index,Green] := Index;
    Screen[Index,Blue]  := 0;
  END;
  FOR Index := 192 TO 255 DO
  BEGIN
    Screen[Index,Red]   := 0;
    Screen[Index,Green] := 191-Index;
    Screen[Index,Blue]  := 0;
  END;

  FOR Index := 256 TO 318 DO
  BEGIN
    Screen[Index,Red]   := Index;
    Screen[Index,Green] := 0;
    Screen[Index,Blue]  := 0;
  END;
  FOR Index := 319 TO 382 DO
  BEGIN
    Screen[Index,Red]   := 382-Index;
    Screen[Index,Green] := 0;
    Screen[Index,Blue]  := 0;
  END;
END;



PROCEDURE SetPal(Brightnes:Byte);
VAR I,Col:Byte; Up:Boolean;

  PROCEDURE SetCol(N:Integer; R,G,B:Byte);
  BEGIN
    Screen[N,Red]   := R;
    Screen[N,Green] := G;
    Screen[N,Blue]  := B;
  END;

 FUNCTION C:Byte;
 BEGIN
   C := Col+Brightnes;
 END;

BEGIN
  Col := 0;
  Up  := True;
  FOR I := 0 TO 32 DO
  BEGIN
    SetCol(I     ,C,C,C-5);
    SetCol(I+32  ,0,0,C);
    SetCol(I+65  ,0,C,0);
    SetCol(I+98  ,0,C,C);
    SetCol(I+131 ,C,0,0);
    SetCol(I+164 ,C,0,C);
    SetCol(I+197 ,C,C-8,0);
    SetCol(I+230 ,C,C,C);
    SetCol(I+263 ,C,C,0);
    SetCol(I+296 ,0,C,C-5);
    SetCol(I+329 ,C-5,0,C);
    SetCol(I+362 ,C,C-5,C);
    IF Up THEN Inc(Col) ELSE Dec(Col);
    IF Col = 16 THEN Up := False;
  END;
END;


PROCEDURE MoveBars;
VAR Pal1,Pal2:TPalColor; I:Integer;
BEGIN
  Pal1 := Screen[1];
  Move(Screen[2],Screen[1],SizeOf(Screen) - (Sizeof(TPalColor)*6) );
  Screen[394] := Pal1;
END;


PROCEDURE Initialize;
BEGIN
  FillChar(Screen,SizeOf(Screen),0);  SetPal(13);
  FillChar(Clear,SizeOf(Clear)-1,' ');
  Index := 2;
  WHILE Index <= 160 DO
  BEGIN
    Clear[Index] := #7;
    Inc(Index,2);
  END;
  GetVGAPal(Pal);
END;



{---------------------------------------------------------------------------}
{------------------------------- MAIN PROGRAM ------------------------------}
{---------------------------------------------------------------------------}
BEGIN
  Initialize;
  FadeDownMax;
  ShowLOGO;
  SetBorderColor(7);
  FadeUpMax;
  ASM CLI END;
  REPEAT
    VRetrace;
    MoveBars;
    FOR Index := 1 TO 400 DO
    BEGIN
      Port[$3C8] := 0;
      Port[$3C9] := Screen[Index,Red];
      Port[$3C9] := Screen[Index,Green];
      WHILE (Port[$3DA] AND 1) <> 0 DO;
      WHILE (Port[$3DA] AND 1) = 0 DO;
      Port[$3C9] := Screen[Index,Blue];
    END;
  UNTIL Port[$60] = 1;
  MemW[Seg0040:$1A] := MemW[Seg0040:$1C];         {Clear KBD buffer}
  Mem[Seg0040:$17] := Mem[Seg0040:$17] AND NOT 4; {Clear CTRL pressed}
  ASM STI END;
  SetBorderColor(0);
  Move(Clear,Ptr($B800,24*160)^,SizeOf(Clear)-1);
END.